import logging
import gtk
from gettext import gettext as _

import quitappletplus.util as utils
import quitappletplus.action

__author__="roman"
__date__ ="$28.11.2008 10:31:14$"


class TestSettings(object):

    def __init__(self):
        self.another_users_logged_in = False
        self.shutdown_permitted = True
        self.close_dialog = None

    def get_other_users(self):
        return (_("User 1"), _("User 2"))

    def show_settings(self):
        if not self.close_dialog:
            self.close_dialog = utils.CloseDialog(
                    _("Quit Applet Plus Test scenarios"), self.__create_view())
            self.close_dialog.dialog.connect(
                                          "destroy", self.__setting_dialog_closed)
        else:
            self.close_dialog.present()

    #actually not in use...
    def perform_ctrl_alt_delete(self, widget, data=None):
        logging.debug("Testing: ctrl+alt+delete executed")
        group = quitappletplus.action.QuitGroup()
        group.perform_quit()

    def __logged_in_users_changed(self, togglebutton):
        self.another_users_logged_in = togglebutton.get_active()
        logging.debug("Testing: another_users_logged_in=%s" % self.another_users_logged_in)

    def __shutdown_permitted_changed(self, togglebutton):
        self.shutdown_permitted = not togglebutton.get_active()
        logging.debug("Testing: shutdown_permitted=%s" % self.shutdown_permitted)

    def __setting_dialog_closed(self, widget):
        self.close_dialog = None

    def __create_view(self):
        tooltip = gtk.Tooltips()

        another_users_logged_in_box = gtk.CheckButton(_("Other users are logged in"))
        another_users_logged_in_box.set_active(self.another_users_logged_in)
        tooltip.set_tip(another_users_logged_in_box,
            _("Expected result: 'Power Off' and 'Restart' shouldn't be accessible directly"))
        another_users_logged_in_box.connect("toggled", self.__logged_in_users_changed)

        shutdown_permit_box = gtk.CheckButton(_("Power Off / Reboot not permitted"))
        shutdown_permit_box.set_active(not self.shutdown_permitted)
        tooltip.set_tip(shutdown_permit_box,
            _("Expected result: 'Power Off' and 'Restart' cannot be performed"))
        shutdown_permit_box.connect("toggled", self.__shutdown_permitted_changed)

        ctrl_alt_delete_button = gtk.Button()
        ctrl_alt_delete_button.set_label(_("Simulate 'Ctrl + Alt + Delete'"))
        ctrl_alt_delete_button.connect("clicked", self.perform_ctrl_alt_delete)

        view = gtk.VBox(homogeneous=False, spacing=5)
        view.set_border_width(20)
        view.pack_start(another_users_logged_in_box, expand=False)
        view.pack_start(shutdown_permit_box, expand=False)
#this issue is rejected ;) view.pack_start(ctrl_alt_delete_button, expand=False)
        return view


settings = TestSettings()


if __name__ == "__main__":
    print "Hello! I'm the testing modul, and who are you? ;)";


